const Generator = require('yeoman-generator');

// TODO: lint-staged
// TODO: Storybook
// TODO: CI/CD setup
// TODO: State management
// TODO: Styling
// TODO: Plain JS/flow

class ReactAppGenerator extends Generator {
  async getUserInput() {
    let prompt = this.prompt([
      {
        type: 'input',
        name: 'appname',
        message: 'Your project name',
        default: this.appname,
      },
      {
        type: 'input',
        name: 'description',
        message: 'A description of your project',
      },
    ]);

    this.options = await prompt;
  }

  copyFiles() {
    let files = [
      'config/jest/adapter.ts',
      'src/App.tsx',
      'src/index.tsx',
      'README.md',
      'package.json',
      ['template.gitignore', '.gitignore'],
      'tsconfig.json',
      'webpack.config.ts',
    ];

    files.map(file => {
      let inFile, outFile;

      if (Array.isArray(file)) {
        inFile = file[0];
        outFile = file[1];
      } else {
        inFile = file;
        outFile = file;
      }

      this.fs.copyTpl(
        this.templatePath(inFile),
        this.destinationPath(outFile),
        this
      );
    });
  }

  installDeps() {
    const deps = ['react', 'react-dom', 'react-hot-loader'];

    const devDeps = [
      '@types/enzyme',
      '@types/enzyme-adapter-react-16',
      '@types/html-webpack-plugin',
      '@types/react',
      '@types/react-dom',
      '@types/webpack',
      'babel-loader',
      'cross-env',
      'enzyme',
      'enzyme-adapter-react-16',
      'html-webpack-plugin',
      'jest',
      'prettier',
      'rimraf',
      'ts-jest',
      'ts-loader',
      'ts-node',
      'typescript',
      'webpack',
      'webpack-cli',
      'webpack-dev-server',
    ];

    this.yarnInstall(deps);
    this.yarnInstall(devDeps, { dev: true });
  }
}

module.exports = ReactAppGenerator;
