import { Configuration, HotModuleReplacementPlugin } from 'webpack';
import * as HtmlWebpackPlugin from 'html-webpack-plugin';

const config: Configuration = {
  mode: process.env.NODE_ENV === 'production' ? 'production' : 'development',
  entry: './src/index.tsx',
  resolve: {
    extensions: ['.ts', '.tsx', '.js', '.jsx', '.json'],
  },
  module: {
    rules: [
      {
        test: /\.tsx?$/,
        use: [
          {
            loader: 'babel-loader',
            options: {
              plugins: 'react-hot-loader/babel',
            },
          },
          'ts-loader',
        ],
      },
    ],
  },
  devServer: {
    historyApiFallback: true,
    host: '0.0.0.0',
    hot: true,
    inline: true,
  },
  plugins: [new HotModuleReplacementPlugin(), new HtmlWebpackPlugin()],
};

export default config;
